<template>
  <div class="main-container fr-p-2w">
    <AtomLoader
      v-if="pending"
      class="fr-mx-auto"
    />
    <AtomAlert
      v-else-if="error"
      :alert-type="AlertType.Error"
      message="Les statistiques de la répartion des départements ou services de l'administration centrale n'ont pas pu être chargées."
    />
    <template v-else-if="departementServiceCounts">
      <h2 class="fr-h5">
        Départements ou services de l'administration centrale
      </h2>
      <StatsList
        v-if="departementServiceCounts.length"
        :total-count="beneficiaryCount"
        :stats="departementServiceCounts"
        stats-bar
      />
      <p v-else>
        Commencez à
        <NuxtLink
          :to="Routes.BeneficiariesAdd"
          target="_self"
          >créer des fiches de bénéficiaires</NuxtLink
        >
        pour voir apparaître les statistiques de la répartition des départements
        ou services de l'administration centrale.
      </p>
    </template>
  </div>
</template>

<script setup>
  import { MINISTERE_DEPARTEMENT_SERVICE_AC_OPTIONS } from '~/utils/constants/beneficiary'
  import { AlertType } from '~~/utils/constants/alert'
  import { errorResponseMessage } from '~~/utils/errorResponse'
  import { labelOrUnprovided } from '~~/utils/stats'
  import { Routes } from '~/utils/routing/routes'

  const { $getItems } = useNuxtApp()

  const props = defineProps({
    beneficiaryCount: {
      type: Number,
      required: true
    },
    filters: {
      type: Object,
      required: true
    }
  })

  const {
    data: departementServiceCounts,
    pending,
    error,
    refresh
  } = useLazyAsyncData(
    'departementServiceCounts',
    loadDepartementServiceCounts,
    {
      server: false
    }
  )

  watch(() => props.filters, refresh)

  async function loadDepartementServiceCounts() {
    const res = await $getItems('beneficiary', {
      groupBy: 'ministere_departement_service_ac',
      aggregate: { countDistinct: 'id' },
      filter: props.filters
    })

    if (res.status === 200) {
      const departementServiceResCounts = res.data.data.map(
        departementService => ({
          key: departementService.ministere_departement_service_ac,
          label: labelOrUnprovided(
            departementService.ministere_departement_service_ac,
            MINISTERE_DEPARTEMENT_SERVICE_AC_OPTIONS
          ),
          count: parseInt(departementService.countDistinct.id)
        })
      )
      departementServiceResCounts.sort((a, b) => b.count - a.count)
      return departementServiceResCounts
    }
    throw new Error(errorResponseMessage(res))
  }
</script>
